- HTTP request
- Path parameters
- Request body
- Response body
- Authorization scopes
- IAM Permissions
- Try it!
Advises on whether extending an existing future reservation is possible based on the desired extension end time. If capacity isn't available for the entire requested duration, the method recommends the longest possible extension.
HTTP request
POST https://compute.googleapis.com/compute/beta/projects/{project}/regions/{region}/advice/calendarModeExtension The URLs use gRPC Transcoding syntax.
Path parameters
| Parameters | |
|---|---|
project |
Project ID for this request. |
region |
Name of the region for this request. |
Request body
The request body contains data with the following structure:
| JSON representation |
|---|
{ "futureReservation": string, "endTimeNotLaterThan": string } |
| Fields | |
|---|---|
futureReservation |
Required. Reference to the future reservation, in the format: projects/{project}/zones/{zone}/futureReservations/{name} Full URIs that include hostnames (like compute.googleapis.com or www.googleapis.com) are also supported. |
endTimeNotLaterThan |
Required. The desired end time for the extension. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
Response body
A response that contains the recommended duration for extending a future reservation in calendar mode based on available capacity during the extension period.
If successful, the response body contains data with the following structure:
| JSON representation |
|---|
{ "recommendationId": string, "endTime": string, "notRecommendedReason": { "status": enum, "details": string } } |
| Fields | |
|---|---|
recommendationId |
The unique ID of the recommendation, which is a UUID string generated by the API. |
endTime |
The recommended end time for the extension, which is either the end time requested by the caller or the longest alternative with sufficient capacity. If the extension is not possible, this field is empty, and notRecommendedReason is populated instead. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
notRecommendedReason |
The reason why the future reservation can't be extended. If a recommendation is provided, whether for the requested end time or an alternative, this field is empty. |
notRecommendedReason.status |
Status of recommendation. |
notRecommendedReason.details |
Human-readable details describing why the recommendation wasn't provided. For example, if the status is CONDITIONS_NOT_MET, this field explains why the requested extension duration isn't possible. |
Authorization scopes
Requires one of the following OAuth scopes:
https://www.googleapis.com/auth/computehttps://www.googleapis.com/auth/cloud-platform
For more information, see the Authentication Overview.
IAM Permissions
In addition to any permissions specified on the fields above, authorization requires one or more of the following IAM permissions:
compute.advice.calendarMode
To find predefined roles that contain those permissions, see Compute Engine IAM Roles.